package com.talkfun.cloudlive.helper;

import android.content.Context;
import android.media.AudioManager;

public class AudioManagerHelper {

    AudioManager audioManager;
    int maxVolume;
    int oldVolume = Integer.MIN_VALUE;

    public  AudioManagerHelper(Context context){
        audioManager = (AudioManager) context.getSystemService(Context.AUDIO_SERVICE);
        maxVolume = audioManager.getStreamMaxVolume(AudioManager.STREAM_MUSIC);
    }

    public void setVolume(int volume){

        audioManager.setStreamVolume(AudioManager.STREAM_MUSIC,volume,AudioManager.FLAG_SHOW_UI);
    }

    public int getVolumen(){
         return audioManager.getStreamVolume(AudioManager.STREAM_MUSIC);
    }

    public void startVolumenOffset(){
        oldVolume = getVolumen();
    }

    public void volumenoffset(float offsetPercentage){
        if(oldVolume == Integer.MIN_VALUE)
            oldVolume = getVolumen();
        int newVolume = (int)(offsetPercentage * maxVolume) + oldVolume;
        setVolume(newVolume);
    }

    public void stopVolumenOffset(){
        oldVolume = Integer.MIN_VALUE;
    }

}
