### 初始化SDK逻辑

#### 创建对象

- SDK相关播放逻辑是通过HtSdk对象实现，HtSdk是一个单例对象，调用初始化方法进行初始化
- 特别说明的是，在初始化HtSdk对象时需要access_token
- 需要提供摄像头视频容器和ppt容器

```
//1.首先获取容器对象和access_token值
//白板布局容器竖屏模式一般设置4:3
FrameLayout pptContainer;   // 白板布局容器
FrameLayout videoViewContainer;  // 摄像头视频播放器布局容器
String access_token; //直播access_token

//2.通过getInstance()方法获取HtSdk对象实例
HtSdk mHtSdk = HtSdk.getInstance();

//3.通过init()方法传1中的对象值初始化SDK
//调用init重载方法
//init(ViewGroup whiteboardViewContainer, ViewGroup videoViewContainer,String token, //boolean isPlayback),最后的参数isPlayback传为true进行点播回放初始化
mHtSdk.init(pptContainer, videoViewContainer, access_token,true);

//4.设置进入后台是否暂停（默认是暂停）(可选)
mHtSdk.setPauseInBackground(true);

//5.调用onResume方法
//SDK在调用HtSdk对象的onResum方法时去加载数据
//如在Activity中调用，可对应Activity的onResume方法
//否则在初始化完成后调用
mHtSdk.onResume();
```

#### 暂停Activity

```
//在app退回后台时，调用onPause方法
//可对应Activity的onPause方法
//如果不设置setPauseInBackground或设置为true时，执行暂停播放
mHtSdk.onPause();
```

#### 释放注销对象

```
//如果退出播放Activity，调用release方法释放HtSdk对象
//调用release方法后，须再次调用init方法初始化
mHtSdk.release();
```



**到此为止已经简单地实例化了SDK，已经具有播放音视频以及显示ppt的功能。**

