# 欢拓云课堂Android SDK接入文档

* 欢拓云课堂Android SDK接入文档

-----

*   [概述](./README.md)

*   [特性](./character.md)

*   [准备开始](./prepareStart.md)
    *   [阅读对象](./be_suitable_for_reader.md)

    *   [开发准备](./prepare.md)

    *   [前置条件](./precondition.md)

    *   [版本升级须知](./version_update.md)

*   [常见问题](./faq.md)
    *   [自定义状态视图](./faq/status_views.md)
    *   [混淆](./faq/proguard.md)
    *   [如何支持后台播放](./faq/play-in-background.md)
    *   [报NoClassDefFoundError错误](./faq/noClassDefFoundError.md)
    *   [其他非原生语言的接入](./faq/other_language.md)

*   [快速开始](./quick_start.md)

    *   [初始化SDK逻辑（直播）](./SDK_live_init.md)

    *   [初始化SDK逻辑（点播）](./SDK_playback_init.md)

    *   [离线播放实现逻辑](./offline.md)


*   [功能说明](./function_use.md)
    *   [公共定义说明](./define.md)

    *   [直播接口说明](./live/index.md)
        *   [房间](./live/room.md)
        *   [直播状态](./live/live.md)
        *   [视频](./live/video.md)
        *   [白板](./live/whiteboard.md)
        *   [用户](./live/member.md)
        *   [聊天](./live/chat.md)
        *   [提问](./live/question.md)
        *   [投票](./live/vote.md)
        *   [抽奖](./live/lottery.md)
        *   [鲜花](./live/flower.md)
        *   [公告](./live/announce.md)
        *   [广播](./live/broadcast.md)
        *   [评分](./live/score.md)

    *   [点播接口说明](./TalkfunSDK_Playback.md)        ​      
        *   [聊天](./playback/chat.md)
        *   [问答](./playback/question.md)
        *   [点播倍数播放](./playback/playback_rate.md)    

    *   [离线播放说明](./TalkfunDownloadManager.md)
    *   [网络选择说明](./network.md)
    *   [伪直播说明](./fakeLive.md)


*   [SDK下载](./download.md)

