###离线播放
#####下载管理类

**com.talkfun.sdk.offline.PlaybackDownloader**

   离线下载播放管理类，单例

	public static PlaybackDownloader getInstance()
	获取PlaybackDownloader实例
	
	public void init(Context context)
	初始化点播下载页
	
	public void setDownLoadThreadSize(int mCorePoolSize)
	设置可同时下载的线程数
	参数：
		－mCorePoolSize 线程数
	
	public void setRootFolder(String path)
	设置下载文件存放目录
	参数：
		－path 存放文件目录
	
	public List<String> getPlaybackIdList()
	获取下载队列的播放Id列表
	
	public boolean containsID(String id)
	点播是否已经在下载队列
	参数：
		－id 点播id
		
	public void appendDownloadTask(String token, String id, @Nullable String title,@Nullable final String thumbnailImageUrl，PreDownLoad.OnappendDownloadListener listener)
	添加下载任务
	参数：
		－token 点播token
		－id 点播id
		－title 标题
		－thumbnailImageUrl 缩略图url
		－listener 添加下载任务事件回调
		
	public ArrayList<DownloadInfoMode> getDownloadList()
	获取下载任务信息列表
	 	
	public DownloadInfoMode getDownloadInfo(String playbackID)
	根据点播id获取对应的下载任务信息
	参数：
	－id 点播id
	获取点播任务信息
	
	public Bitmap getThumbnailImage(String id, String url)
	获取点播任务的缩略图
	参数：
		－id 点播id
		－url 任务信息中缩略图url
	
	public String getThumbnailPath(String id, String url) 
	获取离线缩略图的本地路径
	参数：
		－id 点播id
		－url 缩略图url
	
	public void startDownload(String playbackId) 
	开始下载
	参数：
		－playbackId 下载点播id
	
	public void pauseDownload(String playbackId);
	暂停下载
	参数：
		－playbackId 下载点播id
	
	public void pauseAllDownload() 
	全部暂停下载
	
	public void deleteDownload(String playbackId)
	删除下载任务
	参数：
		－playbackId 下载点播id
	
	public void addDownLoadObserver(String playbackId,DownLoadManager.DownLoadObserver observer)
	添加下载监听
	参数：
		－observer 下载监听
		
	public void removeObserver(String playbackId)
	根据点播id移除下载监听
	
	public void removeAllObserver()
	移除所有下载监听
	
	public void destroy()
**com.talkfun.sdk.offline.http.DownLoadManager.DownLoadObserver**
下载监听接口

	void onDownLoadInfoChange(DownloadInfoMode info)
	下载信息变化
	参数:
		－info 下载任务信息列表


**com.talkfun.sdk.offline.http.PreDownLoad.OnappendDownloadListener**
添加下载任务事件回调接口

	void success();
	添加成功
	void fail(int code, String msg);
	添加失败



**com.talkfun.sdk.offline.mode.DownloadInfoMode**

下载任务信息

| 参数                | 类型     | 描述          |
| ----------------- | ------ | ----------- |
| id                | String | 回放id        |
| title             | String | 标题          |
| token             | String | 回放令牌        |
| totalSize         | long   | 总大小         |
| finishSize        | long   | 下载大小        |
| totalNum          | int    | 总文件数        |
| finishNum         | int    | 已下载文件数      |
| duration          | int    | 总时长，单位为秒（s） |
| thumbnailImageUrl | String | 缩略图URL      |


**com.talkfun.sdk.offline.PlaybackDownloader.Status**
下载状态

```
STATE_UNDOWNLOAD 未下载
STATE_DOWNLOADING 正在下载
STATE_PAUSEDOWNLOAD 暂停下载
STATE_WAITINGDOWNLOAD 等待下载
STATE_DOWNLOADFAILED 下载失败
STATE_DOWNLOADED 下载完成
```