# 数据接口说明

# 点播

###初始化监听

```
调用示例：

HtSdk.getInstance().setPlaybackListener(new PlaybackListener() {
 	@Override
 	public void initSuccess() {
 	//初始化完成
 	}
 	
 	@Override
 	public void onInitFail(String msg) {
 	//初始化失败
 	}

});

```



###视频缓冲监听

```
调用示例：

HtSdk.getInstance().setOnPlayerLoadStateChangeListener(new OnPlayerLoadStateChangeListener() {
	@Override
	public void onPlayerLoadStateChange(int loadState) {
	if (loadState == PlayerLoadState.MEDIA_INFO_BUFFERING_START) {
		Log.d(TAG, "缓冲开始");
	} else if (loadState == PlayerLoadState.MEDIA_INFO_BUFFERING_END) {
			Log.d(TAG, "缓冲结束");
		}
	}
});
```



### 课程信息:

- PlaybackInfo是一个单例
- 包含了回放基础信息
- 在调用PlaybackListener 的 initSuccess（）后获取

`@参数说明：`

| 参数                | 类型      | 描述     |
| ----------------- | ------- | ------ |
| liveId            | String  | 回放id   |
| title             | String  | 标题     |
| durationLong      | long    | 总时长    |
| isAlbum           | boolean | 是否包含专辑 |
| currentAlbumIndex | int     | 当前专辑索引 |

```
	调用示例：
	long duration = PlaybackInfo.getInstance().getDurationLong();
```



### 专辑：

#### 获取专辑信息

**com.talkfun.sdk.module.AlbumItemEntity**
专辑信息

`@参数说明：`

| 参数          | 类型     | 描述    |
| ----------- | ------ | ----- |
| id          | String | 回放id  |
| accessToken | String | 回放令牌  |
| title       | String | 标题    |
| thumbSrc    | String | 缩略图地址 |

```
调用示例：
List<AlbumItemEntity> albumItemEntities = PlaybackDataManage.getInstance().getAlbumList();
```

### 播放

```
HtSdk.getInstance().playbackResume();
```

### 暂停

```
HtSdk.getInstance().playbackPause();
```

###停止

```
HtSdk.getInstance().playbackStop();
```


###跳转

`@参数说明：`

| 参数   | 类型   | 描述       |
| ---- | ---- | -------- |
| time | long | 跳转的时间（秒） |

```
HtSdk.getInstance().playbackSeekTo(time);
```

###重播

```
HtSdk.getInstance().replayVideo();
```

###播放专辑

```
调用示例：
List<AlbumItemEntity> albumList = PlaybackDataManage.getInstance().getAlbumList();
int currentIndex = PlaybackInfo.getInstance().getCurrentAlbumIndex();
HtSdk.getInstance().playAlbum(albumList.get(currentIndex));
```

