# 聊天

###文字聊天

### 公共聊天: `BroadcastCmdType.CHAT_SEND`

`@参数说明：`

| 参数       | 类型       | 描述      |
| -------- | -------- | ------- |
| msg      | String   | 发送的消息内容 |
| callback | Callback | 发送回调    |


```
调用示例：

 mHtSdk.emit(BroadcastCmdType.CHAT_SEND, "hello world", new Callback() {
                @Override
                public void success(Object result) {
                   ...
                }

                @Override
                public void failed(String failed) {
                   ...
                }
            });
```


## 数据接收接口


### 文字消息: 

**com.talkfun.sdk.module.ChatEntity**

聊天信息

`@参数说明：`

| 参数       | 类型     | 描述      |
| -------- | ------ | ------- |
| xid      | String | 用户唯一ID  |
| uid      | String | 合作方用户ID |
| nickname | String | 用户昵称    |
| role     | String | 用户角色    |
| gender   | String | 用户性别    |
| avatar   | String | 用户头像地址  |
| msg      | String | 消息内容    |
| time     | String | 时间戳     |
```
调用示例：
	mHtSdk.setHtDispatchChatMessageListener(new HtDispatchChatMessageListener() {
	@Override
	public void receiveChatMessage(ChatEntity entity) {
	...
	}
});
```





### 禁言: `BroadcastCmdType.CHAT_DISABLE`
`@返回数据:`
```
{"cmd":"chat:disable","args":{"xid":337861,"nickname":"rrrr"}}
```

`@参数说明:`

| 参数       | 类型     | 描述     |
| -------- | ------ | ------ |
| xid      | String | 用户唯一ID |
| nickname | String | 用户昵称   |


```
调用示例：
mHtSdk.on(BroadcastCmdType.CHAT_DISABLE, new Emitter.Listener() {
	@Override
	public void call(Object... objects) {
		...
	}
});
        
```

### 解除禁言: `BroadcastCmdType.CHAT_ENABLE`
`@返回数据:`
```
{"cmd":"chat:enable","args":{"xid":337861,"nickname":"rrrr"}}
```

`@参数说明:`

| 参数       | 类型     | 描述     |
| -------- | ------ | ------ |
| xid      | String | 用户唯一ID |
| nickname | String | 用户昵称   |


```
调用示例：
mHtSdk.on(BroadcastCmdType.CHAT_ENABLE, new Emitter.Listener() {
	@Override
	public void call(Object... objects) {
		...
	}
});
        
```

### 全体禁言/解禁: `BroadcastCmdType.CHAT_DISABLE_ALL`
`@返回数据:`
```
{"cmd":"chat:chat:disable:all","args":{"status":0}}
```

`@参数说明:`

| 参数     | 类型   | 描述              |
| ------ | ---- | --------------- |
| status | int  | 禁言状态(0:解禁，1:禁言) |


```
调用示例：
mHtSdk.on(BroadcastCmdType.CHAT_DISABLE_ALL, new Emitter.Listener() {
	@Override
	public void call(Object... objects) {
		...
	}
});
        
```
