# 提问

##调用接口

### 提问:`BroadcastCmdType.QUESTION_ASK`

`@参数说明：`

| 参数       | 类型       | 描述   |
| -------- | -------- | ---- |
| msg      | String   | 提问内容 |
| callback | Callback | 发送回调 |


```
调用示例：
 mHtSdk.emit(BroadcastCmdType.QUESTION_ASK, "hello world", new Callback() {
                @Override
                public void success(Object result) {
                   ...
                }

                @Override
                public void failed(String failed) {
                   ...
                }
            });
```


### 回复提问:`BroadcastCmdType.QUESTION_REPLY`

`@参数格式:`

| 参数       | 类型       | 描述      |
| -------- | -------- | ------- |
| replyId  | String   | 回复的提问ID |
| msg      | String   | 回复内容    |
| callback | Callback | 发送回调    |


```
调用示例：
	JSONObject data = new JSONObject();
	data.put("replyId", "40437");
	data.put("msg","老师我有个问题!")
	mHtSdk.emit(BroadcastCmdType.QUESTION_REPLY, data, new Callback() {
		@Override
		public void success(Object result) {
			...
		}
		@Override
		public void failed(String failed) {
			...
		}
	}
```

---
##广播通知

### 接收问答: 

**com.talkfun.sdk.module.QuestionEntity**

问答信息

`@参数说明：`

| 参数          | 类型                   | 描述      |
| ----------- | -------------------- | ------- |
| id          | String               | 问答ID    |
| xid         | String               | 用户唯一ID  |
| uid         | String               | 合作方用户ID |
| replyId     | String               | 回复的问题ID |
| role        | String               | 角色      |
| content     | String               | 内容      |
| nickname    | String               | 昵称      |
| answerList  | List<QuestionEntity> | 回复列表    |
| isAnswer    | boolean              | 是否为回复   |
| isHasAnswer | boolean              | 是否有回复   |
| time        | String               | 时间戳     |

```
调用示例：

mHtSdk.setHtDispatchQuestionListener(new HtDispatchQuestionListener() {
            @Override
            public void receiveQuestion(QuestionEntity questionEntity) {
                ...
            }
        });
```