#   视频

### 视频监听

* 当由课件模式或桌面分享/视频插播模式切换时，会调用该事件监听的onVideoModeChanging和onVideoModeChanged方法
* 当视频（摄像头视频和桌面分享/插播视频）开始、停止播放时调用onVideoStart和onVideoStop方法
* 当摄像头视频显示隐藏时调用onCameraShow和onCamerahide方法

**com.talkfun.sdk.module.VideoModeType**

视频模式类型

`@参数说明：`

| 参数           | 类型   | 描述             |
| ------------ | ---- | -------------- |
| CAMERA_MODE  | int  | 摄像头视频类型（静态变量）  |
| DESKTOP_MODE | int  | 桌面分享视频类型（静态变量） |

```

调用示例：
HtSdk.getInstance().setOnVideoChangeListener(new OnVideoChangeListener() {
	@Override
	public void onVideoStart(int mode) {
	//视频开始播放
	}
	
	@Override
	public void onVideoStop(int mode) {
	//视频停止播放
	}
	
	@Override
	public void onVideoModeChanging(int beforeMode, int currentMode) {
	//视频模式切换中
	}
	
	@Override
	public void onVideoModeChanged() {
	//视频模式切换完成
	}
	
	@Override
	public void onCameraShow() {
	//摄像头显示
	}
	
	@Override
	public void onCameraHide() {
	//摄像头隐藏
	}
});
```

