# 投票

### 投票监听: 

**com.talkfun.sdk.module.VoteEntity**

投票信息

`@参数说明：`

| 参数        | 类型               | 描述              |
| --------- | ---------------- | --------------- |
| vid       | String           | 投票id            |
| title     | String           | 标题              |
| imageUrl  | String           | 标题              |
| label     | String           | 标签              |
| nickname  | String           | 发起者的昵称          |
| startTime | String           | 发起投票时间          |
| optional  | int              | 投票的形式：单选 1,多选 2 |
| opList    | List<VoteOption> | 选项              |

**com.talkfun.sdk.module.VoteOption**

投票选项

`@参数说明：`

| 参数      | 类型     | 描述   |
| ------- | ------ | ---- |
| content | String | 内容   |


**com.talkfun.sdk.module.VotePubEntity**

投票结果

`@参数说明：`

| 参数                  | 类型                    | 描述                                       |
| ------------------- | --------------------- | ---------------------------------------- |
| vid                 | String                | 投票id                                     |
| title               | String                | 标题                                       |
| imageUrl            | String                | 标题                                       |
| label               | String                | 标签                                       |
| nickname            | String                | 发起者的昵称                                   |
| startTime           | String                | 发起投票时间                                   |
| endTime             | String                | 结束投票时间                                   |
| BriefVoteEntityList | List<BriefVoteEntity> | 各项投票结果                                   |
| answer              | String                | 投票答案，只有当选有答案时才有值，多项答案为"0,1,2"类似字符串，第一项索引为0 |
| options             | String                | 用户选择的选项，为"[1, 2]"类似字符串，第一项索引为1           |

**com.talkfun.sdk.module.BriefVoteEntity**

投票结果项

`@参数说明：`

| 参数      | 类型     | 描述     |
| ------- | ------ | ------ |
| op      | String | 选项内容   |
| opNum   | int    | 选择该项人数 |
| percent | int    | 选择该项比例 |

```
调用示例：
mHtSdk.setHtVoteListener(new HtVoteListener() {
            @Override
            public void voteStart(VoteEntity voteEntity) {
             //投票开始
            }

            @Override
            public void voteStop(VotePubEntity votePubEntity) {
            //投票结束
            }
        });
```



### 发送投票：

`@参数说明：`

| 参数       | 类型                             | 描述                            |
| -------- | ------------------------------ | ----------------------------- |
| vid      | String                         | 投票id                          |
| opts     | String                         | 选择序号（从1开始算起）数组的字符串 ；例："[1,2]" |
| callback | com.talkfun.sdk.event.Callback | 回调                            |

```
调用示例：
HtSdk.getInstance().sendVote(vid,"[1,2]", callback);
```
