### 网络选择

*	如果当前网络速度不理想，SDK提供了接口更改网络
*	直播、伪直播和点播回放切换网络线路的接口统一化

```
//获取网络列表
- void getNetworkList(OnGetNetworkChoicesCallback listener)

//设置网络
- void setNetwork(int linePosition, NetItem item, OnSetNetworkCallback callback)
```

**com.talkfun.sdk.module.NetWorkEntity**

网络信息

`@参数说明：`

| 参数       | 类型          | 描述               |
| -------- | ----------- | ---------------- |
| cdnItems | String      | CDN线路项信息列表       |
| Network  | NetworkInfo | 网络信息，点播或伪直播该属性为空 |

**com.talkfun.sdk.module.CDNItem**

CDN线路项信息

`@参数说明：`

| 参数         | 类型            | 描述               |
| ---------- | ------------- | ---------------- |
| operators  | List<NetItem> | 节点列表，点播或伪直播该属性为空 |
| sourceName | String        | 来源               |

**com.talkfun.sdk.module.NetItem**

节点信息

*	点播或伪直播没有节点信息

`@参数说明：`

| 参数   | 类型     | 描述   |
| ---- | ------ | ---- |
| name | String | 名称   |
| key  | String | 类型   |


**com.talkfun.sdk.module.NetworkInfo**

网络位置信息

*	点播或伪直播没有网络位置信息

`@参数说明：`

| 参数       | 类型     | 描述   |
| -------- | ------ | ---- |
| location | String | 位置   |
| isp      | String | 运营商  |
| ip       | String | ip地址 |

#### 调用示例：

```
//网路选择
//获取网络数据
HtSdk.getInstance().getNetworkList(new OnGetNetworkChoicesCallback() {
	@Override
	public void onGetChoicesSuccess(NetWorkEntity netWorkEntity){
		//获取成功
		...
	}
	@Override
	public void onGetChoicesError(String msg) {
		//获取失败
		...
	}
);

//设置网络
HtSdk.getInstance().setNetwork(linePosition, item, new OnSetNetworkCallback() {
	@Override
	public void onSwitchSuccess() {
		//设置成功
	}
	@Override
	public void onSwitchError() {
		//设置失败
	}
}); 
```