### 回放聊天

####获取聊天数据

**com.talkfun.sdk.module.ChatEntity**

聊天信息

`@参数说明：`

| 参数       | 类型     | 描述      |
| -------- | ------ | ------- |
| xid      | String | 用户唯一ID  |
| uid      | String | 合作方用户ID |
| nickname | String | 用户昵称    |
| role     | String | 用户角色    |
| gender   | String | 用户性别    |
| avatar   | String | 用户头像地址  |
| msg      | String | 消息内容    |
| time     | String | 时间戳     |

```
调用示例：

List<ChatEntity> list = PlaybackDataManage.getInstance().getChatList();
```

####设置回放聊天获取数据监听

```
调用示例： 

PlaybackDataManage.getInstance().setChatListener(new HtDispatchPlaybackMsgListener() {
	@Override
	public void getPlaybackMsgSuccess(int position) {
		//更新数据 									
		setChatList(PlaybackDataManage.getInstance().getChatList());
		if (position < chatMsgList.size()) {
			chatLv.setSelection(position);
		} 
		else {
			chatLv.setSelection(chatMsgList.size() - 1);
		}
	}
	
	@Override
	public void getPlaybackMsgFail(String error) {
	//更新数据失败
	}
});
```

####上拉加载更多聊天数据

```
调用示例：

PlaybackDataManage.getInstance().loadDownMoreData(PlaybackDataManage.DataType.CHAT);
```
####下拉加载更多聊天数据

```
调用示例：

PlaybackDataManage.getInstance().loadDownMoreData(PlaybackDataManage.DataType.CHAT);
```
####自动滚动跟随
```
调用示例：

AutoScrollListener autoScrollListener = new AutoScrollListener() {
	@Override
	public void scrollToItem(int pos) {
		if (isShow && chatAdapter != null) {
		getActivity().runOnUiThread(new Runnable() {
			@Override
			public void run() { 		setChatList(PlaybackDataManage.getInstance().getChatList());
				if (pos < chatMsgList.size()) {
					chatLv.setSelection(pos);
				} 
				else {
				chatLv.setSelection(chatMessageEntityList.size() - 1);
				}
			}
		});
		}
	}
};
PlaybackDataManage.getInstance().startAutoScroll(autoScrollListener, PlaybackDataManage.DataType.CHAT);
```

####停止滚动跟随

```
调用示例：
PlaybackDataManage.getInstance().stopAutoScroll();
```

