### 快速开始
#### 开发环境配置
*	使用Android Studio开发工具
  *  引入SDK
  *  将libs目录下的TalkFunSD.jar文件拷贝到项目工程Application Module的libs目录
  *  右键点击jar文件，并点击弹出菜单中的“Add As Library”并将jar文件作为类库添加到项目中
  *  在项目工程Application Module的src/main目录中新建名为“jniLibs”的目录
  *  将libs/armeabi、armeabi-v7a、x86目录拷贝到“jniLibs”目录中


* 引入依赖库
  *  在Application module的build.gradle文件添加第三方依赖库

  ```
     dependencies {
  		compile 'com.google.code.gson:gson:2.8.0'
  		implementation 'com.github.bumptech.glide:glide:4.5.0'
  		annotationProcessor 'com.github.bumptech.glide:compiler:4.5.0'
  		compile 'com.squareup.retrofit2:retrofit:2.3.0'
  		compile 'com.squareup.retrofit2:converter-gson:2.3.0'
  		compile 'com.squareup.retrofit2:adapter-rxjava2:2.3.0'
  		compile 'io.reactivex.rxjava2:rxandroid:2.0.1'
  		compile 'io.reactivex.rxjava2:rxjava:2.1.0'
  		compile 'io.socket:socket.io-client:0.8.3'
  		compile 'org.nanohttpd:nanohttpd:2.2.0'
       	}
  ```

* 配置AndroidManifest.xml

  * 添加SDK需要的权限到<manifest>标签下
  ```
    <!--允许访问网络权限-->
    <uses-permission android:name="android.permission.INTERNET" /> 
    <!-- 允许检查网络状态权限-->
    <uses-permission android:name="android.permission.ACCESS_NETWORK_STATE"/>
    <uses-permission android:name="android.permission.ACCESS_WIFI_STATE" />
    <uses-permission android:name="android.permission.READ_PHONE_STATE" />
    <uses-permission android:name="android.permission.WRITE_EXTERNAL_STORAGE" />
    <uses-permission android:name="android.permission.READ_EXTERNAL_STORAGE" />
    <uses-permission android:name="android.permission.MOUNT_UNMOUNT_FILESYSTEMS" />
  ```

  * 在相应的Activity标签添加声明configChanges属性,添加configChanges属性配置"keyboardHidden|orientation|screenSize"匹配横屏事件，使在屏幕方向改变时系统不重启Activity

  ```
    android:configChanges="keyboardHidden|orientation|screenSize"
  ```




*	使用欢拓云课堂SDK，必须传入一个access_token，该access_token的获取，参考[申请密钥](./getAccessToken.md)流程

  ​

**到此，你已完成了SDK的依赖添加**